<template>
  <div class="app-container">
    <baidu-map class="map-container" v-bind="mapOptions" @click="mapMoveEnd">
      <bm-control ::offset="{ width: '30px', height: '10px' }">
        <bm-auto-complete v-model="mapKeyword" :sugStyle="{ zIndex: 100000 }">
          <el-row :gutter="2">
            <el-col :span="22">
              <el-input v-model="mapKeyword" placeholder="请输入搜索关键字"></el-input>
            </el-col>
            <el-col :span="2">
              <el-button type="primary" @click="mapSearch">确定</el-button>
            </el-col>
          </el-row>
        </bm-auto-complete>
      </bm-control>
    </baidu-map>
  </div>
</template>
<script>
import { BaiduMap, BmControl, BmAutoComplete } from 'vue-baidu-map/components';

export default {
  components: { BaiduMap, BmControl, BmAutoComplete },
  props: {},
  data() {
    return {
      mapOptions: {
        ak: '42xN1Fhp3VCKvKQRprbfsR48ZbvDbOD0',
        center: { lng: 119.691445, lat: 31.512202 },
        scrollWheelZoom: true,
        zoom: 16
      },
      mapKeyword: '宜兴市'
    };
  },
  methods: {
    mapSearch() {
      let geoCoder = new BMap.Geocoder();
      /* 获取位置对应的坐标 */
      geoCoder.getPoint(this.mapKeyword, point => {
        this.$emit('locationChanged', { searchConfirmed: true, lng: point.lng, lat: point.lat });
      });
    },
    mapMoveEnd(e) {
      const { lng, lat } = e.point;
      this.$emit('locationChanged', {
        lng,
        lat
      });
    }
  }
};
</script>

<style lang="scss" scoped>
.map-container {
  position: absolute;
  top: 0;
  left: 0;
  bottom: 0;
  right: 0;
}
</style>
